#!/bin/bash

# BASH interpreter needs for this scrypt

###### SETTINGS ######
# logefile path
LOG=/tmp/gpio.log
# flags path
FLGPATH=/tmp

# GPIO numbers list
declare -a GPIOLIST
GPIOLIST=(18 19 20 21 22)
# GPIO ways [in, out, off] off - no used
declare -a GPIOTYPE
GPIOTYPE=(in in off out out)
# GPIO names
declare -a GPIONAME
GPIONAME=(door1 door2 power relay1 relay2)
# GPIO actives
# passive
declare -a GPIOPASS
GPIOPASS=(close close ON OFF OFF)
# active
declare -a GPIOACT
GPIOACT=(open open loss ON ON)

# Motion daemon control
MOTION_PID='/tmp/motion.pid';

# SMS sending number in format +15555555555 (dont send if not set) gnokii needs
# SMSNUMBER=+79815555555
# MAIL sending address (dont send if not set) msmtp needs
# MAILADDRESS=e@mail.ru


#######  DONT EDIT LATER ########

# PHP scrypt setting path
PHPSET=/tmp
# create PHP settings
PHPSET="$PHPSET/gpiosettings.php"
echo "<?php " > $PHPSET
STR='$log'
echo "$STR='$LOG';" >> $PHPSET
STR='$flgpath'
echo "$STR='$FLGPATH';" >> $PHPSET
STR='$motion_pid'
echo "$STR='$MOTION_PID';" >> $PHPSET

CNT=1
STR='$gpiolist = array('
for i in "${GPIOLIST[@]}"; do 
  STR="$STR'$i'"
  if [ $CNT -lt ${#GPIOLIST[@]} ]; then 
      STR="$STR,"
  fi 
  CNT=$((CNT + 1))
done
echo "$STR);" >> $PHPSET
CNT=1
STR='$gpiotype = array('
for i in "${GPIOTYPE[@]}"; do 
  STR="$STR'$i'"
  if [ $CNT -lt ${#GPIOTYPE[@]} ]; then 
      STR="$STR,"
  fi 
  CNT=$((CNT + 1))
done
echo "$STR);" >> $PHPSET

CNT=1
STR='$gpioname = array('
for i in "${GPIONAME[@]}"; do 
  STR="$STR'$i'"
  if [ $CNT -lt ${#GPIONAME[@]} ]; then 
      STR="$STR,"
  fi 
  CNT=$((CNT + 1))
done
echo "$STR);" >> $PHPSET
CNT=1
STR='$gpiopass = array('
for i in "${GPIOPASS[@]}"; do 
  STR="$STR'$i'"
  if [ $CNT -lt ${#GPIOPASS[@]} ]; then 
      STR="$STR,"
  fi 
  CNT=$((CNT + 1))
done
echo "$STR);" >> $PHPSET
CNT=1
STR='$gpioact = array('
for i in "${GPIOACT[@]}"; do 
  STR="$STR'$i'"
  if [ $CNT -lt ${#GPIOACT[@]} ]; then 
      STR="$STR,"
  fi 
  CNT=$((CNT + 1))
done
echo "$STR);" >> $PHPSET

echo "?>" >> $PHPSET

# GPIO ways preset
NGPIO=$(cat /sys/class/gpio/gpiochip0/ngpio)

CNT=0
for i in "${GPIOLIST[@]}"; do
    echo $i > /sys/class/gpio/unexport
    echo $i > /sys/class/gpio/export
    echo ${GPIOTYPE[CNT]} > /sys/class/gpio/gpio$i/direction
    declare -a GPIOSTAT
      GPIOSTAT+=(0)
    declare -a GPIODREB
      GPIODREB+=(0)
    echo " Set ${GPIOTYPE[CNT]} for GPIO$i "
   
    CNT=$((CNT + 1))
  done

# logging function
log(){
   message="$(date +"%y-%m-%d %T"): $@"
   echo $message
   echo $message >>$LOG
     }
     
log "Starting monitoring"



while [ 2 -lt 3 ] ; do

	if [ -f "$FLGPATH/reboot.flg" ]; then    
	    reboot
	fi

	CNT=0
	for i in "${GPIOLIST[@]}"; do
          FLG="$FLGPATH/GPIO$i.flg"
          # FOR SWITCHS AND CONTACTS
          if [ ${GPIOTYPE[CNT]} == in ]; then
	      if [ $(cat /sys/class/gpio/gpio$i/value) == 1 ]; then
	    	      if [ ${GPIODREB[CNT]} -lt 10 ]; then
	    	            GPIODREB[CNT]=`expr ${GPIODREB[CNT]} + 1`
	    	      fi
		      if [ ${GPIODREB[CNT]} == 2 ]; then
		  GPIOSTAT[CNT]=1
		  log "${GPIONAME[CNT]} ${GPIOACT[CNT]}"
		  touch $FLG
		  # SMS warning
		  #        echo "Power down!" | gnokii --sendsms +79815555555 --smsc +79112009993
		    fi
		  else
		if [ ${GPIOSTAT[CNT]} == 1 ]; then
		  GPIOSTAT[CNT]=0
		  GPIODREB[CNT]=0
		  log "${GPIONAME[CNT]} ${GPIOPASS[CNT]}"
		  rm $FLG
	      fi
	    fi            
          fi
          # FOR RELAYS AND OTHER
          if [ ${GPIOTYPE[CNT]} == out ]; then
	     if [ -f "$FLG" ]
	     then
		if [ ${GPIOSTAT[CNT]} == 0 ]; then  
		    echo 1 > /sys/class/gpio/gpio$i/value
		    log "${GPIONAME[CNT]} ${GPIOACT[CNT]}"
		    GPIOSTAT[CNT]=1
		fi
	     else
		if [ ${GPIOSTAT[CNT]} == 1 ]; then
		    echo 0 > /sys/class/gpio/gpio$i/value
		    log "${GPIONAME[CNT]} ${GPIOPASS[CNT]}"
		    GPIOSTAT[CNT]=0
		fi
	     fi				
          fi
	  CNT=$((CNT + 1))
	done

     sleep 1
#    clear         
done


